/*
   rprintf.c

   a mixture of Uros Platise's mini rprintf.c and DJ Delorie's doprnt.c

	Adapted for Flash source --
	Devin Cook (dsc@oz.net)
	02-03-00

  Note:
  PUTC(ch) must be defined somewhere!
  %T or %t is used for Text (Rom Based Strings!)

  example:  rom_printf("This is a ROM Test written on %T",PSTR(__DATE__));
  														^---          ROM strings         ---^
     vs:
       			printf("This is a RAM Test written on %s",__DATE__);
  									^---          RAM strings         ---^
*/

#ifndef __RPRINTF_H__
#define __RPRINTF_H__

#include <stdarg.h>
#include <progmem.h>

#define RAM_STRING		0
#define FLASH_STRING	(!RAM_STRING)

#define printf(format, args...)  			rprintf (RAM_STRING, 	format 			 , ## args)
#define rom_printf(format, args...)  	rprintf (FLASH_STRING, PSTR(format) , ## args)

extern int rprintf(unsigned char Flash_Flag, const char *format, ...);


#endif // __RPRINTF_H__